#include <kxmainwindow.h>
#include <kconfig.h>
#include "kxextinfodialog.h"
#include <klocale.h>
#include <qhbox.h>
#include <qframe.h>
#include <qlayout.h>
#include <kiconloader.h>
#include <kdialogbase.h>
#include <kxinfo_basicimpl.h>
#include <kxinfo_homeimpl.h>
#include <kxinfo_phoneimpl.h>
#include <kxinfo_workimpl.h>
#include <kxinfo_aboutimpl.h>
#include <kxinfo_extraimpl.h>
#include <kxengine.h>
#include <qlayout.h>
#include <kxengine.h>

kxExtInfoDialog::kxExtInfoDialog( QWidget *parent=0, const char *name=0) :
  KDialogBase(IconList, i18n("Info"), Ok|Cancel, Ok, parent, name, false, true)
{
  setShowIconsInTreeList(FALSE);

  uin=ENGINE->ourUin;
  setCaption(i18n("Update Own Information"));


  QStringList list;
/*  QString tmp;
  for (int t=1; t<=50; t++)
  {
    tmp.sprintf("kde/%04d",t);
    list.append(tmp);
  }

  sendAnim=new KAnimWidget(list, 22, this, "anim");
  sendAnim->move(5,height()-22-5);
  sendAnim->resize(25,25);*/
  

/*  list << QString(" ")+i18n("Basic");
  setFolderIcon(list,BarIcon("basic"));
  list.clear();
  list << QString(" ")+i18n("Home");
  setFolderIcon(list,BarIcon("basic"));
	list.clear();*/

  list.clear();
  list << QString(" ")+i18n("Basic Information") << i18n(" Basic");
  QFrame *frame = addHBoxPage(list, i18n("Basic Information"));
  basicInfo=new kxInfoBasicImpl(this,frame);
//  basicInfo->networkGroup->hide();
  widgets.append(basicInfo);
  list.clear();
  list << QString(" ")+i18n("Home Information") << i18n(" Home");
  frame = addHBoxPage(list, i18n("Home Information"));
  homeInfo=new kxInfoHomeImpl(this,frame);
  widgets.append(homeInfo);
  list.clear();
  list << QString(" ")+i18n("Work Information") << i18n(" Work");
  frame = addHBoxPage(list, i18n("Work Information"));
  workInfo=new kxInfoWorkImpl(this,frame);
  widgets.append(workInfo);
  list.clear();
  list << QString(" ")+i18n("Phone Book") << i18n(" Phone");
  frame = addHBoxPage(list, i18n("Phone Book Information"));
  phoneInfo=new kxInfoPhoneImpl(this,frame);
  widgets.append(phoneInfo);
  list.clear();
  list << QString(" ")+i18n("Extra Information") << i18n(" Extra");
  frame = addHBoxPage(list, i18n("Extra Information"));
  extraInfo=new kxInfoExtraImpl(this,frame);
  widgets.append(extraInfo);
  list.clear();
  list << QString(" ")+i18n("About Information") << i18n(" About");
  frame = addHBoxPage(list, i18n("About Information"));
  aboutInfo=new kxInfoAboutImpl(this,frame);
  widgets.append(aboutInfo);
  	
  resize(600,425);
  kxInfoFrame *sw;
  for (Q_UINT16 t=0; t<widgets.count(); t++)
  {
    sw=(kxInfoFrame *)widgets.at(t);
    if (sw) sw->disableAll();
    if (sw) sw->init();
  }

  QObject::connect(ENGINE, SIGNAL(SignalReceivedMoreInfo(Q_UINT16, Q_UINT16, Q_UINT8, QString, Q_UINT16,Q_UINT8,Q_UINT8,Q_UINT8,Q_UINT8,Q_UINT8)),
                    this,SLOT(SlotMoreInfo(Q_UINT16, Q_UINT16, Q_UINT8, QString, Q_UINT16,Q_UINT8,Q_UINT8,Q_UINT8,Q_UINT8,Q_UINT8)));
  QObject::connect(ENGINE, SIGNAL(SignalReceivedMainHomeInfo(Q_UINT16, QString,QString,QString,QString,QString,QString,QString,QString,QString,QString,QString,Q_UINT16, Q_UINT8, Q_UINT8)), this, SLOT(SlotReceivedMainHomeInfo(Q_UINT16, QString,QString,QString,QString,QString,QString,QString,QString,QString,QString,QString,Q_UINT16, Q_UINT8, Q_UINT8)));
  QObject::connect(ENGINE, SIGNAL(SignalSearchEnd(Q_UINT16)), this, SLOT(SlotSearchEnd(Q_UINT16)));
  QObject::connect(ENGINE, SIGNAL(SignalReceivedEmailInfo(Q_UINT16, QStringList)), this, SLOT(SlotEmailInfo(Q_UINT16, QStringList)));
  QObject::connect(ENGINE, SIGNAL(SignalReceivedWorkInfo(Q_UINT16, QString, QString,QString,QString,QString,QString,QString,QString,QString,QString,Q_UINT16,Q_UINT16)),
  									this, SLOT(SlotWorkInfo(Q_UINT16, QString, QString,QString,QString,QString,QString,QString,QString,QString,QString,Q_UINT16,Q_UINT16)));
	QObject::connect(ENGINE, SIGNAL(SignalReceivedAboutInfo(Q_UINT16, QString)), this, SLOT(SlotAboutInfo(Q_UINT16, QString)));
	QObject::connect(ENGINE, SIGNAL(SignalSearchFailed(Q_UINT16)), this, SLOT(SlotSearchFailed(Q_UINT16)));	

	seq=ENGINE->sendRequestOwnInfo(ENGINE->ourUin);
	if (seq==0) close();

}
void kxExtInfoDialog::slotOk()
{
  slotApply();
  KDialogBase::slotOk();  
}
void kxExtInfoDialog::slotApply()
{
  kxInfoFrame *sw;
  for (Q_UINT16 t=0; t<widgets.count(); t++)
  {
    sw=(kxInfoFrame *)widgets.at(t);
    if (sw) sw->apply();
  }

  if (nick!=onick || first!=ofirst || last!=olast || primEmail!=oprimEmail || city!=ocity || state!=ostate ||
  		phone!=ophone || fax!=ofax || street!=ostreet || gsm!=ogsm || zip!=ozip || country!=ocountry || gmt!=ogmt || pubEmail!=opubEmail)
	  ENGINE->sendMainHomeInfo(nick, first, last, primEmail, city, state, phone, fax, street, gsm, zip, country, gmt, pubEmail);
	
  ENGINE->sendEmailList(lst);

  if (wName!=owName || wPos!=owPos || wDiv!=owDiv || wStreet!=owStreet || wZip!=owZip || wCity!=owCity || wState!=owState || wUrl!=owUrl ||
  		wPhone!=owPhone || wFax!=owFax || wCountry!=owCountry || wOccu!=owOccu)
	  ENGINE->sendWorkInfo(wName,  wPos, wDiv,wStreet, wZip, wCity, wState, wUrl,wPhone, wFax, wCountry, wOccu);
	
  if (about!=oabout)
	  ENGINE->sendAboutInfo(about);
	
	if (age!=oage || sex!=osex || homepage!=ohomepage || year!=oyear || day!=oday || month!=omonth || lang1!=olang1 || lang2!=olang2 || lang3!=olang3  )
	  ENGINE->sendMoreInfo(age, sex, homepage, year, day, month, lang1, lang2, lang3);
	
  MAINWINDOW->setBasicInfo(nick, first, last, primEmail);
}

void kxExtInfoDialog::SlotReceivedMainHomeInfo(Q_UINT16 s, QString _n,QString _f,QString _l,QString _e,QString _c,QString _st,QString _p,QString _fa,QString _ste,QString _ce,QString _zip,Q_UINT16 _con, Q_UINT8 _gmt, Q_UINT8 _pubEmail)
{
  if (seq==s)
  {
  	nick=_n;
		first=_f;
		last=_l;
		street=_ste;
		city=_c;
		state=_st;
		primEmail=_e;
		phone=_p;
		fax=_fa;
		gsm=_ce;
		country=_con;
		gmt=_gmt;
		pubEmail=_pubEmail;
  	onick=_n;
		ofirst=_f;
		olast=_l;
		ostreet=_ste;
		ocity=_c;
		ostate=_st;
		oprimEmail=_e;
		ophone=_p;
		ofax=_fa;
		ogsm=_ce;
		ocountry=_con;
		ogmt=_gmt;
		opubEmail=_pubEmail;		
		homeInfo->SlotReceivedMainHomeInfo( _n, _f, _l, _e, _c, _st, _p, _fa, _ste, _ce,_zip, _con, _gmt, _pubEmail);  	
		basicInfo->SlotReceivedMainHomeInfo( _n, _f, _l, _e, _c, _st, _p, _fa, _ste, _ce,_zip, _con, _gmt, _pubEmail);  	
		phoneInfo->setHome(_p, _fa, _ce);
  }
}
void kxExtInfoDialog::SlotMoreInfo(Q_UINT16 s,Q_UINT16 _age, Q_UINT8 _sex, QString _homepage, Q_UINT16 j,Q_UINT8 d,Q_UINT8 m,Q_UINT8 l1,Q_UINT8 l2,Q_UINT8 l3)
{
  if (seq==s)
  {
		homepage=_homepage;
		age=_age;
		year=j;
		sex=_sex;
		day=d;
		month=m;
		lang1=l1;
		lang2=l2;
		lang3=l3;
		ohomepage=_homepage;
		oage=_age;
		oyear=j;
		osex=_sex;
		oday=d;
		omonth=m;
		olang1=l1;
		olang2=l2;
		olang3=l3;
		extraInfo->setExtra(_age, _sex, _homepage, j, d, m, l1, l2, l3);
  }
}
void kxExtInfoDialog::SlotAboutInfo(Q_UINT16 s, QString _a)
{
  if (seq==s)
  {
  	about=_a;
  	oabout=_a;
  	aboutInfo->setAbout(_a);
  }
}
void kxExtInfoDialog::SlotWorkInfo(Q_UINT16 s, QString _c, QString _s,QString _ph, QString _f,QString _st,QString _z,QString _cn,QString _cd,QString _cp,QString _cw,Q_UINT16 _co,Q_UINT16 _ocu)
{
  if (seq==s)
  {
		wStreet=_st;
		wName=_cn;
		wPos=_cp;
		wDiv=_cd;
		wZip=_z;
		wCity=_c;
		wState=_st;
		wUrl=_cw;
		wOccu=_ocu;
		wCountry=_co;
		wPhone=_ph;
		wFax=_f;
		owStreet=_st;
		owName=_cn;
		owPos=_cp;
		owDiv=_cd;
		owZip=_z;
		owCity=_c;
		owState=_st;
		owUrl=_cw;
		owOccu=_ocu;
		owCountry=_co;
		owPhone=_ph;
		owFax=_f;		
  	workInfo->setWork(_cn, _cp, _cd, _st, _z, _c, _s, _cw, _co, _ocu);
  	phoneInfo->setWork(_ph, _f);
  }
}
void kxExtInfoDialog::SlotSearchEnd(Q_UINT16 s)
{
	if (seq==s)
  {
    kxInfoFrame *sw;
    for (Q_UINT16 t=0; t<widgets.count(); t++)
    {
      sw=(kxInfoFrame *)widgets.at(t);
      if (sw) sw->enableAll();
    }  	
	}  	
}
void kxExtInfoDialog::SlotSearchFailed(Q_UINT16 s)
{
	if (seq==s)
  {
	}
}
void kxExtInfoDialog::SlotEmailInfo(Q_UINT16 s, QStringList lst)
{
	if (seq==s)
  {
  	for (Q_UINT16 t=0; t<lst.count(); t+=2)
  	{
  		basicInfo->addEmail(lst[t], lst[t+1]=="Y"?TRUE:FALSE);	
  	}
  }
}

void kxExtInfoDialog::setMain(QString _n, QString _f, QString _l, QString _e, bool _p)
{
	nick=_n;
	last=_l;
	first=_f;
	pubEmail=_p;
	primEmail=_e;
}
void kxExtInfoDialog::setHome(QString _st, QString _ci, QString _s, QString _z, Q_UINT16 _c, Q_UINT8 _gm)
{
	street=_st;
	city=_ci;
	state=_s;
	zip=_z;
	country=_c;
	gmt=_gm;
}
void kxExtInfoDialog::setWork(QString _cn, QString _cp,QString _cd, QString _s,QString _z, QString _c,QString _st, QString _cw, Q_UINT16 _co, Q_UINT16 _ocu)
{
  wStreet=_s;
  wName=_cn;
  wPos=_cp;
  wDiv=_cd;
  wZip=_z;
  wCity=_c;
  wState=_st;
  wUrl=_cw;
  wOccu=_ocu;
  wCountry=_co;
}
void kxExtInfoDialog::setEmailList(const QStringList &_lst)
{
	lst=_lst;
}
void kxExtInfoDialog::setWorkPhone(QString _p, QString _f)
{
	wPhone=_p;
	wFax=_f;
}
void kxExtInfoDialog::setHomePhone(QString _p, QString _f, QString _c)
{
	phone=_p;
	fax=_f;
	gsm=_c;
}
void kxExtInfoDialog::setAbout(QString _a)
{
	about=_a;
}
void kxExtInfoDialog::setExtra(Q_UINT16 _age, Q_UINT8 _sex, QString _homepage, Q_UINT16 j,Q_UINT8 d,Q_UINT8 m,Q_UINT8 l1,Q_UINT8 l2,Q_UINT8 l3)
{
		homepage=_homepage;
		age=_age;
		year=j;
		sex=_sex;
		day=d;
		month=m;
		lang1=l1;
		lang2=l2;
		lang3=l3;	
}
